offhandViewmodel <- null;
lastThrowTS <- 0;

PrecacheScriptSound("Player.DenyWeaponSelection")
PrecacheScriptSound("WeaponMedigun_Vaccinator.Toggle")
PrecacheScriptSound("Player.HitSoundRetro")
PrecacheScriptSound("Player.DenyWeaponSelection")
PrecacheScriptSound("MVM_Weapon_Bottle.HitFlesh")

PrecacheSound("vip_v7/coin_boost_received.mp3")
PrecacheSound("vip_v7/coin_regen.mp3")
PrecacheSound("vip_v7/coin_throw_minicrits.mp3")
PrecacheSound("vip_v7/coin_throw_resistance.mp3")
PrecacheSound("vip_v7/coin_throw_speed.mp3")

vipBoostTokensStart <- 3;
vipBoostTokensMax <- 3;
vipBoostTokens <- 3;
game_text_vip_boost <- null;
tokenRecharge <- 0;
selectedBuffType <- 0;

OnSelfEvent("init_custom_character", 0, function()
{
    vipBoostTokens = 3;
    game_text_vip_boost = SpawnEntityFromTable("game_text",
    {
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 5,
        holdtime = 5,
        message = "",
        x = -1,
        y = 0.6
    });
});

OnSelfEvent("post_inventory_application", 1, function()
{
    offhandViewmodel = CreateViewModel(coin_viewmodel);
    offhandViewmodel.ResetSequence(offhandViewmodel.LookupSequence("coin_idle"));
    offhandViewmodel.SetCycle(0);
    offhandViewmodel.SetPlaybackRate(1);
});

AddTimer(0.1, function()
{
    local playersOnCountCounter = safeget(extraData, "playersOnCountCounter", 0)
    local selectedBuffTypeStr = selectedBuffType == 0 ? "Mini-Crits" : selectedBuffType == 2 ? "Speed Boost" : "Healing"
    EntFireByHandle(game_text_vip_boost "AddOutput",
    "message Selected buff∶ " + selectedBuffTypeStr
        +"\nBuff Tokens∶ " + vipBoostTokens+BigToSmallNumbers(tokenRecharge)
        +"\n\n\n\n\nPress 1-3 to switch buffs. Right click to throw a buff."
        +"\nPlayers near Point∶ "+playersOnCountCounter, 0, self, self);
    EntFireByHandle(game_text_vip_boost "Display", "", 0, self, self);
});

AddTimer(-1, function()
{
    local buttons = GetPropInt(self, "m_nButtons");
    if (vipBoostTokens > 0 && buttons & IN_ATTACK2)
    {
        local time = Time();
        if (time < lastThrowTS)
            return;
        lastThrowTS = time + 1;
        vipBoostTokens--;
        if (vipBoostTokens <= 0)
            offhandViewmodel.SetBodygroup(0, 3);

        /*local viewmodel = GetPropEntity(self, "m_hViewModel");
        if (viewmodel)
        {
            viewmodel.SetSequence(viewmodel.LookupSequence("pipe_idle_test"))
        }*/

        offhandViewmodel.ResetSequence(offhandViewmodel.LookupSequence("coin_throw"));
        offhandViewmodel.SetCycle(0);
        RunWithDelay(0.5, function() {
            offhandViewmodel.ResetSequence(offhandViewmodel.LookupSequence("coin_idle"));
        })

        local team = self.GetTeam();

        local selfplayer = self;

        RunWithDelay(-1, function() {
            local projectile = SpawnEntityFromTable("prop_physics_override", {
                model = coin_worldmodel,
                origin = self.EyePosition()
                spawnflags = "4",
                massscale = 31
            });
            projectile.SetPhysVelocity(self.EyeAngles().Forward() * 4400 + Vector(0, 0, 200));
            projectile.SetGravity(0.1);

            if (selectedBuffType == 0)
                projectile.EmitSound("vip_v7/coin_throw_minicrits.mp3");
            else if (selectedBuffType == 1)
                projectile.EmitSound("vip_v7/coin_throw_resistance.mp3");
            else if (selectedBuffType == 2)
                projectile.EmitSound("vip_v7/coin_throw_speed.mp3");

            AddTimer(-1, function(vipContext)
            {
                local location = self.GetOrigin();
                local trace = {
                    start = location,
                    end = location,
                    hullmin = Vector(-42, -42, -42),
                    hullmax = Vector(42, 42, 42),
                    ignore = selfplayer
                };
                TraceHull(trace);
                local player = safeget(trace, "enthit", null);
                if (!IsValidPlayer(player))
                {
                    TraceHull(trace);
                    local trace = {
                        start = location,
                        end = location,
                        hullmin = Vector(-8, -8, -8),
                        hullmax = Vector(8, 8, 8),
                        ignore = selfplayer
                    };
                    TraceHull(trace);
                    player = safeget(trace, "enthit", null);
                }
                if (player)
                {
                    if (IsValidPlayer(player) && (player.InCond(TF_COND_DISGUISED) || player.GetTeam() == team))
                    {
                        if (buffType == 0)
                            vipContext.AttachBuff(player, TF_COND_OFFENSEBUFF, 8);
                        else if (buffType == 2)
                            vipContext.AttachBuff(player, TF_COND_SPEED_BOOST, 8);
                        else
                            player.AddCondEx(TF_COND_HALLOWEEN_QUICK_HEAL, 2, vipContext.self);
                        EmitSoundEx({
                            sound_name = "vip_v7/coin_boost_received.mp3"
                            filter_type = RECIPIENT_FILTER_SINGLE_PLAYER
                            entity = player
                        });
                        player.ValidateScriptScope();
                        player.GetScriptScope().PlaySoundForAnotherPlayer(vipContext.self, "vip_v7/coin_boost_received.mp3")
                    }
                    else if (IsValidPlayerOrBuilding(player))
                    {
                        player.EmitSound("MVM_Weapon_Bottle.HitFlesh");
                        player.TakeDamage(50, 0, vipContext.self)
                    }
                    self.Kill();
                }
            }, this, projectile);
            projectile.GetScriptScope().buffType <- selectedBuffType;
        });
    }
});

function AttachBuff(player, condition, duration)
{
    local buffEnt = SpawnEntityFromTable("point_template", {
        teamnum = self.GetTeam()
    });
    EntFireByHandle(buffEnt, "Kill", "", duration, self, self);
    AddTimer(0.1, 0, function()
    {
        if (IsValidPlayer(player))
        {
            if ((player.InCond(TF_COND_STEALTHED) || player.InCond(TF_COND_DISGUISED)) && player.GetTeam() == self.GetTeam())
                return;
            player.AddCondEx(condition, 0.2, self);
        }
        else
            self.Kill();
    }, buffEnt);
}

AddTimer(0.15, 0, function()
{
    if (vipBoostTokens >= vipBoostTokensMax)
    {
        tokenRecharge = 0;
        return;
    }
    tokenRecharge += 3;
    if (tokenRecharge >= 100)
    {
        vipBoostTokens++;
        if (vipBoostTokens == 1)
            offhandViewmodel.SetBodygroup(0, selectedBuffType);
        tokenRecharge = 0;
        EmitSoundEx({
            sound_name = "vip_v7/coin_regen.mp3",
            filter_type = Constants.EScriptRecipientFilter.RECIPIENT_FILTER_SINGLE_PLAYER,
            entity = self,
            speaker_entity = self
        });
    }
});