local canBattleCryTS = Time() + 8;

Include("vip_shared/vcd_table.nut")

AddTimer(-1, function()
{
    for (local scene = null; scene = Entities.FindByClassname(scene, "instanced_scripted_scene");)
    {
        SetPropBool(scene, "m_bForcePurgeFixedupStrings", true);
        scene.KeyValueFromString("classname", "invalid");
        //if (self == NetProps.GetPropEntity(scene, "m_hOwner"))
            PlayVCDReplacement(NetProps.GetPropEntity(scene, "m_hOwner"), scene);
    }
});

function PlayVCDReplacement(player, scene)
{
    local path = NetProps.GetPropString(scene, "m_szInstanceFilename");
    if (!path)
        return;
    /*local splits = split(path, "/");
    if (splits.len() == 1)
        splits = split(path, "\\");
    local str = splits[splits.len() - 1];
    local vcdIndex = str.slice(0, str.len() - 4);*/
    local soundName = safeget(VCDTable, path.tolower(), null);
    /*if (soundName == "battle_cry" && Time() < canBattleCryTS)
        return;*/
    if (!soundName || startswith(soundName, "pain") && RandomInt(0, 2))
        return;
    if (startswith(soundName, "CloakedSpyIdentify"))
        soundName = HandleSpyVoiceLine(player, soundName);

    local scope = "customCharacter" in player.GetScriptScope() ? player.GetScriptScope().customCharacter : player.GetScriptScope();
    BuildSound(soundName.tolower()).Scope(scope).Entity(player).Voice().Play();
}

OnGameEvent("player_domination", function(params)
{
    local player = GetPlayerFromParams(params, "dominator");
    if (player && !RandomInt(0, 2))
        BuildSound("domination").Delay(3).Scope(player).Voice().Play();
});

OnGameEvent("player_death", function(params)
{
    if ((params.damagebits & 128) && !RandomInt(0, 4))
    {
        local attacker = GetPlayerFromParams(params, "attacker");
        if (attacker)
            BuildSound("melee_kill").Delay(2).Scope(attacker).Voice().Play();
    }
});