//=========================================================================
//If this is in a Workshop build, please let us know.
//This isn't supposed to happen.
//=========================================================================

//This way we avoid resetting the mp_timeleft timer when mp_restartgame_immediate happens
if (!GetPersistentVar("m_flMapResetTime", null))
    SetPersistentVar("m_flMapResetTime", GetPropFloat(tf_gamerules, "m_flMapResetTime"));
else
    SetPropFloat(tf_gamerules, "m_flMapResetTime", GetPersistentVar("m_flMapResetTime"));

game_text_debug <- SpawnEntityFromTable("game_text",
{
    color = "236 227 203",
    color2 = "0 0 0",
    channel = 1,
    holdtime = 5,
    message = "",
    spawnflags = 1
    x = -1,
    y = 0.65
});

::debug_dot <- 0;
::debug_mdot <- 0;
::debug_dotC <- 0;
::debug_dotC2 <- 0;
::debug_distance <- 0;
::debug_radius <- 0;

showActivities <- false;

AddTimer(-1, function()
{
    if (showActivities)
    {
        local weapon = GetListenServerHost().GetActiveWeapon();
        printl(weapon.GetSequenceActivityName(weapon.GetSequence()));
    }
})

OnGameEvent("player_say", 0, function(player, params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    local steamId = NetProps.GetPropString(player, "m_szNetworkIDString");
    if (steamId != "[U:1:61845546]"
        && steamId != "[U:1:464940145]"
        && steamId != "[U:1:839712142]"
        && steamId != "[U:1:71264411]"
        && steamId != "[U:1:160070292]"
        && steamId != "[U:1:323372627]"
        && steamId != "[U:1:333558812]")
        return;

    if (params.text.find("killvip") == 1)
    {
        local vip = GetVIP(TF_TEAM_BLUE);
        vip.TakeDamageEx(
            vip,
            vip,
            vip.GetActiveWeapon(),
            Vector(0, 0, 0),
            vip.GetOrigin(),
            9999,
            0);
    }


    local test1 = 5;
    local test2 = 10;

    if (params.text.find("act_on") == 1 || params.text.find("act on") == 1 || params.text.find("activities on") == 1 || params.text.find("activity on") == 1 || params.text.find("activ_on") == 1 || params.text.find("activ on") == 1)
    {
        showActivities <- true;
    }

    if (params.text.find("act_off") == 1 || params.text.find("act off") == 1 || params.text.find("activities off") == 1 || params.text.find("activity off") == 1 || params.text.find("activ_off") == 1 || params.text.find("activ off") == 1)
    {
        showActivities <- false;
    }

    if (params.text.find("taunt") == 1)
    {
        local arg = params.text.slice(7);

        local currentWeapon = player.GetActiveWeapon();

        local weaponEnt = Entities.CreateByClassname("tf_weapon_base");
        SetPropInt(weaponEnt, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", arg.tointeger());
        SetPropBool(weaponEnt, "m_AttributeManager.m_Item.m_bInitialized", true);
        SetPropBool(weaponEnt, "m_bValidatedAttachedEntity", true);
	    SetPropBool(weaponEnt, "m_bClientSideAnimation", true);
        weaponEnt.SetTeam(self.GetTeam());
        weaponEnt.SetOwner(self);
	    SetPropEntity(weaponEnt, "m_hOwnerEntity", self);
        SetPropBool(weaponEnt, "m_bForcePurgeFixedupStrings", true);
        Entities.DispatchSpawn(weaponEnt);
        player.Weapon_Equip(weaponEnt);
        player.Weapon_Switch(weaponEnt);

        player.HandleTauntCommand(0);
        weaponEnt.Kill();
        player.Weapon_Switch(currentWeapon);
    }

    if (params.text.find("!unstuck") == 0)
    {
        SetPersistentVar("unstuck", !GetPersistentVar("unstuck", true));
    }

    if (params.text.find("!restart") == 0)
    {
        ClientPrint(null, 3, "RESTARTING THE ROUND!")
        ClientPrint(null, 3, "RESTARTING THE ROUND!")
        ClientPrint(null, 3, "RESTARTING THE ROUND!")
        ClientPrint(null, 3, "RESTARTING THE ROUND!")
        ClientPrint(null, 3, "RESTARTING THE ROUND!")
        ClientPrint(null, 1, "RESTARTING THE ROUND!")
        ClientPrint(null, 4, "RESTARTING THE ROUND!")

        local roundWin = SpawnEntityFromTable("game_round_win",
        {
            win_reason = "0",
            force_map_reset = "1", //not having
            TeamNum = "0",         //these 3 lines
            switch_teams = "0"     //causes the crash when trying to fire game_round_win
        });
        EntFireByHandle(roundWin, "SetTeam", "0", 0, null, null);
        EntFireByHandle(roundWin, "RoundWin", "", 0, null, null);

        local bonustime = Convars.GetInt("mp_bonusroundtime");
        Convars.SetValue("mp_bonusroundtime", 5);
        RunWithDelay(1, function() {
            Convars.SetValue("mp_bonusroundtime", bonustime);
        }, main_script)
    }

    if (params.text.find("!restart2") == 0)
    {
        ClientPrint(player, 3, "Restarting...")
        Convars.SetValue("mp_restartgame_immediate", "1");
    }

    if (params.text.find("time2") == 1)
    {
        EntFireByHandle(team_round_timer, "AddTime", "+30", 0, null, null);
    }
    else if (params.text.find("time") == 1)
    {
        local timeRemaining = GetPropFloat(team_round_timer, "m_flTimerEndTime") - Time() - 5;
        if (timeRemaining > 10)
            EntFireByHandle(team_round_timer, "AddTime", "-" + (timeRemaining - 10), 0, null, null);
    }
    if (params.text.find("overtime") == 1)
    {
        SetOvertimeAllowedForCTF(true);
        local hax = SpawnEntityFromTable("item_teamflag", {})
        NetProps.SetPropInt(hax, "m_nFlagStatus", 2)
        NetProps.SetPropInt(team_round_timer, "m_bShowTimeRemaining", 0)

        local counter = [Time() + 30];

        AddTimer(1, function()
        {
            NetProps.SetPropFloat(team_round_timer, "m_flTimerEndTime", counter[0] += 2)
        })

        /*local tf_logic_cp_timer = SpawnEntityFromTable("tf_logic_cp_timer",
        {
            targetname = "ass"
            controlpoint = "control_point_4",
        });
        SetPropInt(tf_logic_cp_timer, "m_nTimerLength", 33);
        EntFireByHandle(tf_logic_cp_timer, "RoundSpawn", "", -1, null, null);*/


        //SetOvertimeAllowedForCTF(true);
        //printl(GetPropInt(tf_gamerules, "teamplayroundbased_gamerules_data.m_bInOvertime"))
        //SetPropInt(tf_gamerules, "teamplayroundbased_gamerules_data.m_bInOvertime", 1);
    }
});

::PrintEntity <- function(entity)
{
    local tempTable = {}
    NetProps.GetTable(entity, 1, tempTable)

    if(tempTable != null){
        printl("---------- START DATAMAP DUMP FOR " + entity + " ----------")
        foreach (k,v in tempTable){
            printl(k+" -> "+v)
        }
        printl("----------  END DATAMAP DUMP FOR " + entity + "  ----------")
    }
}

::rateLimiter <- 0;
::totalCounter <- 0;

AddTimer(1, function()
{
    if (rateLimiter > 0)
        rateLimiter--;
})

::FindTheLizard <- function()
{
    local maxPlayers = MaxClients().tointeger();
    for (local i = 1; i <= maxPlayers ; i++)
    {
        local player = PlayerInstanceFromIndex(i)
        if (!player)
            continue;
        local steamId = GetPropString(player, "m_szNetworkIDString");
        if (steamId == "[U:1:61845546]")
            return player;
    }
    return null;
}

if (IsDedicatedServer())
seterrorhandler(function (e)
{
    PrintError(FindTheLizard(), e);
})

::PrintError <- function(player, e)
{
    if (rateLimiter > (player ? 7 : 3) || totalCounter > (player ? 200 : 20))
        return;
    totalCounter++;
    rateLimiter++;
    printl(e)
    local Chat = @(m) ClientPrint(player, 3, m)
    Chat(format("\nAN ERROR HAS OCCURRED [%s]", e))
    Chat("CALLSTACK")
    local s, l = 2
    while (s = getstackinfos(l++))
        Chat(format("*FUNCTION [%s()] %s line [%d]", s.func, s.src, s.line))
    Chat("LOCALS")
    if (s = getstackinfos(3))
        foreach (n, v in s.locals) {
            local t = type(v)
            t ==    "null" ? Chat(format("[%s] NULL"  , n))    :
            t == "integer" ? Chat(format("[%s] %d"    , n, v)) :
            t ==   "float" ? Chat(format("[%s] %.14g" , n, v)) :
            t ==  "string" ? Chat(format("[%s] \"%s\"", n, v)) :
                             Chat(format("[%s] %s %s" , n, t, v.tostring()))
        }
}